# -*- coding: utf-8 -*-
"""
Created on Tue Dec 22 13:28:30 2015

@author: Joep
"""

from jmcb_exp_fun_wage import *
import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl
from scipy.optimize import fsolve

plot = plt.plot

N=40




    
C=[[0]*(N) for hhh in range(4)]
Y=[[0]*N   for hhh in range(4)]
R=[[0]*N   for hhh in range(4)]
P=[[0]*N  for hhh in range(4)]
B=[[0]*N  for hhh in range(4)]
K=[[0]*N  for hhh in range(4)]
INV=[[0]*N  for hhh in range(4)]
Z=[[0]*N  for hhh in range(4)]
Q=[[0]*N  for hhh in range(4)]
g=[[0]*N  for hhh in range(4)]
tau=[[0]*N   for hhh in range(4)]
Trans=[[0]*N   for hhh in range(4)]
LST=[[0]*N   for hhh in range(4)]
C=[[0]*N   for hhh in range(4)]
ri=[[0]*N   for hhh in range(4)]
H=[[0]*N   for hhh in range(4)]
H2=[[0]*N   for hhh in range(4)]
w=[[0]*N   for hhh in range(4)]
w2=[[0]*N   for hhh in range(4)]
mc=[[0]*N   for hhh in range(4)]
Pw=[[0]*N   for hhh in range(4)]
H4=[[0]*N   for hhh in range(4)]
rk=[[0]*N   for hhh in range(4)]

mc=[[0]*(N) for hhh in range(4)]
prof=[[0]*(N) for hhh in range(4)]
Eb0=[0]*N
cf0=[0]*N
cf1=[0]*N
cdif=[0]*N
Eyf1=[0]*N 
Epf1=[0]*N 
Ebf1=[0]*N 
Egf1=[0]*N 
Etf1=[0]*N  
Ecf1=[0]*N 
Ecf0=[0]*N 
Ey=[0]*N 
Ep=[0]*N 
Eg=[0]*N 


Ey1=[0]*N 
Ep1=[0]*N 
Eb1=[0]*N 
Er1=[0]*N 
Ek1=[0]*N  
Ez1=[0]*N  
Ei1=[0]*N  
ET1=[0]*N  
Ew1=[0]*N  
Epw1=[0]*N  

param=dict(
    T=20,
    fount=1-0.99,
    beta=0.99,
    omega=0.8,
    omega_w=1e-100,  #Wage stickyness. Code is flexible enough to introduce this, but for the results in the paper, set it to virtually zero (e.g. 1e-100)
    eta=1.5, 
    sigma=2,
    zeta=0.2,  #power on kaptial in production funcion
    theta=2,
    theta_w=2,
    phi_1=1.5,
    phi_2=0.2,
    phi_b=0.06,
    sstau=0.4,
    ssg=0.2,
    ssb=0.7,
   gamma1=1/0.99-1+0.025,   
   gamma2=0.05,
   delta=0.025,    #depreciation rate
   kappa= 17, #investment adjustmentcost
    )


pers_gs=0.97
pers_ts=0.97
pers_tr=0.97

param=UpdateParam(**param)  



#order of variables in A: Y P b R K Z I LT w Wp

A=np.zeros((10,10))

A[0]=[1-param['nu_y'],-param['yp'],0,-yEiterm(0,**param),param['beta']*param['nu_k'],-(param['nu_z']+param['gamma1']*param['ssk']/param['ssy']),-param['ssi']/param['ssy'],1/param['rho'],-param['nu_w'],0] 
A[1]=[0,1,0,0,0,-param['k_z'],0,0,-param['k_w'],0]
A[2]=[-param['b_y'],param['ssb']/param['beta'],1,-param['ssb'],0,-param['b_z'],0,1/param['beta'],-param['b_w'],0]
A[3]=[-param['phi_2'],-param['phi_1'],0,1,0,0,0,0,0,0]
A[4]=[0,0,0,0,1,0,-param['ssi']/param['ssk'],0,0,0]
A[5]=[-param['z_y'],0,0,0,0,param['z_z'],0,0,-param['z_w'],0]
A[6]=[0,0,0,-iEriterm(0,**param),0,0,1,0,0,0]
A[7]=[0,0,0,0,0,0,0,1,0,0]
A[8]=[0,1,0,0,0,0,0,0,1,-1]
A[9]=[-param['w_y'],0,0,0,param['OmegaBeta_w']*param['w_k'],param['w_z'],param['w_i'],0,param['w_w'],1]

shock=0.01
g[1][1]=shock
tau[0][1]=-shock*param['ssy']/(param['ssh']*param['ssw'])
Trans[3][1]=shock



types=[3,1,0]
for spen in types:  #1 is spending 0 is tax 2 is no fiscal shock 3 is transfers shock
        
    plotexp=1

    
    Update_hd_pol=1 #new policy functions for the high debt steady state path need to be calcualted untill this is set to zero

    
    for i in range(1,N):
        if i>1:
            g[spen][i]=g[spen][i-1]*pers_gs
            tau[spen][i]=tau[spen][i-1]*pers_ts
            Trans[spen][i]=Trans[spen][i-1]*pers_tr
            
        if Update_hd_pol==1:                
            pol_matrix,_=Policy_hdss(A,pers_gs,pers_ts,pers_tr,**param) #update policy fucntions
            Update_hd_pol=0
            
       # expectatinos  
        [exp_IS,exp_Phil,exp_Inv,exp_Pw,Eb0[i],Eyf1[i],Epf1[i],Ebf1[i],Egf1[i],Etf1[i],Ecf0[i],Ecf1[i]]=Expfun(pol_matrix,B[spen][i-1],K[spen][i-1],INV[spen][i-1],g[spen][i],tau[spen][i],w[spen][i-1],Trans[spen][i],pers_gs,pers_ts,pers_tr,plotexp,**param)

        [Ey1[i],Ep1[i],Eb1[i],Er1[i],Ek1[i],Ez1[i],Ei1[i],ET1[i],Ew1[i],Epw1[i]]=[eval_pol(pol_matrix[1],var,B[spen][i-1],K[spen][i-1],INV[spen][i-1],g[spen][i],tau[spen][i],w[spen][i-1],Trans[spen][i]) for var in range(10)] 


        RHS=np.zeros(10)
       
        
        RHS[0]=1/param['rho']*B[spen][i-1]+param['ykl']*K[spen][i-1]+g[spen][i]-param['nu_tau']*tau[spen][i]+exp_IS
        RHS[1]=exp_Phil
        RHS[2]=param['bkl']*K[spen][i-1]+1/param['beta']*B[spen][i-1]+param['b_g']*g[spen][i]+param['b_tau']*tau[spen][i]
        RHS[3]=0
        RHS[4]=(1-param['delta'])*K[spen][i-1]
        RHS[5]=param['zkl']*K[spen][i-1]
        RHS[6]=INV[spen][i-1]+exp_Inv
        RHS[7]=param['phi_b']*B[spen][i-1]-Trans[spen][i]
        RHS[8]=w[spen][i-1]
        RHS[9]=-param['w_k']*K[spen][i-1]-param['w_g']*g[spen][i]+param['w_tau']*tau[spen][i]+exp_Pw
        
        
        Y[spen][i],P[spen][i],B[spen][i],R[spen][i],K[spen][i],Z[spen][i],INV[spen][i],LST[spen][i],w[spen][i],Pw[spen][i]=np.dot(np.linalg.inv(A),RHS)
        C[spen][i]=param['ssy']/param['ssc']*Y[spen][i]-param['ssi']/param['ssc']*INV[spen][i]-param['ssy']/param['ssc']*g[spen][i]-param['gamma1']*param['ssk']/param['ssc']*Z[spen][i]
        ri[spen][i-1]=R[spen][i-1]-P[spen][i]
        H[spen][i]=1/(1-param['zeta'])*Y[spen][i]-param['zeta']/(1-param['zeta'])*K[spen][i-1]-param['zeta']/(1-param['zeta'])*Z[spen][i]
        H2[spen][i]=1/param['eta']*(w[spen][i] -param['sigma']*C[spen][i]-tau[spen][i]/(1-param['sstau']))
        rk[spen][i]=param['gamma2']/param['gamma1']*Z[spen][i]
        mc[spen][i]=(1-param['zeta'])*w[spen][i] +param['zeta']*param['gamma2']/param['gamma1']*Z[spen][i]


        if  i>0: 
            plotexp=0


        print(exp_Inv,INV[spen][i],Y[spen][i])
   
 
Npl=min(N,1000)




for spen in types:            
#    plt.figure(param['T']) 
    plt.figure() 
 
    if spen==1:
    
        plt.subplot(3, 3, 1)
        plot([(g[spen][i])*100 for i in range(Npl)],linewidth=2)
        #    plt.ylim((-0.1,0))
        plt.title('Government spending')
        plt.xlabel('t')
    
    if spen == 0:
        plt.subplot(3, 3, 1)
        plot([(tau[spen][i])*100 for i in range(Npl)],linewidth=2)
        #    plt.ylim((0,0.12))
        plt.title('Labor Taxes')
        plt.xlabel('t')
    
    if spen == 3:
        plt.subplot(3, 3, 1)
        plot([(Trans[spen][i])*100 for i in range(Npl)],linewidth=2)
        #    plt.ylim((0,0.12))
        plt.title('Transfers')
        plt.xlabel('t')
        
     
    plt.subplot(3, 3, 2)
    plot([(B[spen][i]+param['ssb'])*100 for i in range(Npl)],linewidth=2)
#    plt.ylim((70, 78))
    plt.title('Debt')
    plt.ylabel('b_t')
    plt.xlabel('t')



    plt.subplot(3, 3, 3)
    plot([(C[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Consumption')
    plt.ylabel('C_t')
    plt.xlabel('t')   
    
    
    plt.subplot(3, 3, 4)
    plot([(P[spen][i])*400 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.01,0.06))
    plt.title('inflation')
    plt.ylabel('pi_t')
    plt.xlabel('t')
    
    


    

    plt.subplot(3, 3, 5)
    plot([(R[spen][i])*400 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.01,0.04))
    plt.title('nominal interest rate')
    plt.ylabel('R_t')
    plt.xlabel('t')
    plt.show() 
    
    plt.subplot(3, 3, 6)
    plot([(INV[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Investment')
    plt.ylabel('I_t')
    plt.xlabel('t') 
    
    
    plt.subplot(3, 3, 7)
    plot([(K[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Kapital')
    plt.ylabel('Y_t')
    plt.xlabel('t') 
    

    
    plt.subplot(3, 3, 8)
    plot([(Z[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Kapital Utilization')
    plt.ylabel('Y_t')
    plt.xlabel('t') 


 
    plt.subplot(3, 3, 9)
    plot([(Y[spen][i])*100 for i in range(Npl)],linewidth=2)
    #    plt.ylim((-0.08,0.005))
    plt.title('Output')
    plt.ylabel('Y_t')
    plt.xlabel('t')   
    #
    
    
 
