# -*- coding: utf-8 -*-
"""
Created on Tue Dec 22 13:28:30 2015

@author: Joep
"""
from __future__ import division
#from sympy import *
#from sympy.abc import y, p, b, v,l
from copy import deepcopy
import matplotlib.pyplot as plt
import numpy as np

plot = plt.plot





def UpdateParam(**param): 
    param['ssw']=((param['theta']-1)/param['theta'])**(1/(1-param['zeta']))*param['zeta']**(param['zeta']/(1-param['zeta']))*(1-param['zeta'])*param['gamma1']**(-param['zeta']/(1-param['zeta']))
    param['ssk']=(((1-param['ssg'])*((param['gamma1']/param['ssw']*(1-param['zeta'])/param['zeta'])**(1-param['zeta'])-param['delta']/(1-param['ssg'])))**(-param['sigma'])*(1-param['sstau'])*param['ssw']*(param['gamma1']/param['ssw']*(1-param['zeta'])/param['zeta'])**(-param['eta'])*(param['theta_w']-1)/param['theta_w'])**(1/(param['sigma']+param['eta']))
    param['ssh']=param['gamma1']/param['ssw']*(1-param['zeta'])/param['zeta']*param['ssk']
    param['ssy']=(param['gamma1']/param['ssw']*(1-param['zeta'])/param['zeta'])**(1-param['zeta'])*param['ssk']
    
  
    param['ssi']=param['delta']*param['ssk']

    param['ssLST']=(1-param['beta'])*param['ssb']+param['ssg']-param['sstau']*param['ssw']*param['ssh']/param['ssy']
    param['ssc']=param['ssy']*(1-param['ssg'])-param['ssi']
    param['varpi']=param['ssc']**(-param['sigma'])
    
    #more parameters
    param['OmegaBeta']=param['omega']*param['beta']
    param['OmegaBeta_w']=param['omega_w']*param['beta']
    
    #composite parameters
    param['rho']=param['beta']**(param['T']+1)/param['fount']+(1-param['beta']**(param['T']+1))/(1-param['beta'])
    
    param['nu_w']=param['ssw']/param['rho']*param['ssh']/param['ssy']*(1-param['sstau'])-(param['theta']-1)/(param['theta']*param['rho'])*(1-param['zeta'])

    param['nu_y']=1/(param['theta']*param['rho'])+param['ssw']/param['rho']*param['ssh']/param['ssy']*(1-param['sstau'])*1/(1-param['zeta'])

    param['nu_z']=param['gamma2']/(param['gamma1']*param['rho'])*(param['gamma1']*param['ssk']/param['ssy']-(param['theta']-1)/param['theta']*param['zeta'])-param['ssw']/param['rho']*param['ssh']/param['ssy']*(1-param['sstau'])*param['zeta']/(1-param['zeta'])

    param['nu_tau']=param['ssw']/(param['rho'])*param['ssh']/param['ssy']

    param['nu_r']=1/param['rho']*param['ssc']/(param['ssy']*param['sigma'])     

    param['nu_k']=param['ssw']/param['rho']*param['ssh']/param['ssy']*(1-param['sstau'])*param['zeta']/(1-param['zeta'])
  
    param['k_mc']=(1-param['omega'])*(1-param['OmegaBeta'])/param['omega']    
    #derivatives of system with output infaltion lagged debt and debt 2 periods ago, ignoring expectations
    
    param['k_w']=param['k_mc']*(1-param['zeta'])

    param['k_z']=param['k_mc']*param['zeta']*(param['gamma2']/param['gamma1'])

    param['k_pi']=(1-param['omega'])/param['omega']    
  
    param['z_z']=param['gamma2']/param['gamma1']+1/(1-param['zeta'])
    param['z_y']=1/(1-param['zeta'])
    param['zkl']=-1/(1-param['zeta'])

    param['z_w']=1

    param['b_y']=-param['ssh']/param['ssy']*param['ssw']/param['beta']*param['sstau']*1/(1-param['zeta'])

    param['b_w']=-param['ssh']/param['ssy']*param['ssw']/param['beta']*param['sstau']

    
    param['b_g']=1/param['beta']
    param['b_z']=param['ssh']/param['ssy']*param['ssw']/param['beta']*param['sstau']*param['zeta']/(1-param['zeta'])
    param['b_tau']=-param['ssh']/param['ssy']*param['ssw']/param['beta'] 
    
    param['bkl']=param['ssh']/param['ssy']*param['ssw']/param['beta']*param['sstau']*param['zeta']/(1-param['zeta'])
    param['bbl']=1/param['beta']
    
    
    param['ybl']=1/param['rho']
    param['ykl']=param['ssk']/(param['rho']*param['beta']*param['ssy'])-param['nu_k']

    param['yp']=-param['ssb']/(param['rho'])
   
    param['i_z']=param['gamma2']/(param['kappa']*(1-param['delta']))   
    
    param['w_w']= (1-param['omega_w']*param['beta'])*(1-param['omega_w'])/(param['omega_w'])\
    *param['ssc']/(param['ssc']*(1+param['theta_w']*param['eta'])-(param['omega_w']*param['beta'])**(param['T']+1)*(1-param['sstau'])*param['ssw']*param['ssh']*(param['theta_w']-1)  )
    param['w_y']=param['w_w']*(param['eta']/(1-param['zeta'])+param['sigma']*param['ssy']/param['ssc'])
    param['w_k']=param['w_w']*param['eta']*param['zeta']/(1-param['zeta'])
    param['w_g']=param['w_w']*param['sigma']*param['ssy']/param['ssc']
    param['w_tau']=param['w_w']/(1-param['sstau'])
    param['w_i']=param['w_w']*param['sigma']*param['ssi']/param['ssc']
    param['w_z']=param['w_w']*(param['eta']*param['zeta']/(1-param['zeta'])+param['sigma']*param['ssk']*param['gamma1']/param['ssc'])
    param['w_pw']=(1-param['omega_w'])/(param['omega_w'])
    param['w_wt']=(param['omega_w']*param['beta'])**(param['T']+1)*(1-param['omega_w'])/(param['omega_w'])\
    *(param['ssc']+(1-param['sstau'])*param['ssw']*param['ssh']  )/(param['ssc']*(1+param['theta_w']*param['eta'])-(param['omega_w']*param['beta'])**(param['T']+1)*(1-param['sstau'])*param['ssw']*param['ssh']*(param['theta_w']-1)  )

    param['w_w_inf']= (1-param['omega_w']*param['beta'])*(1-param['omega_w'])/(param['omega_w'])\
    *1/(1+param['theta_w']*param['eta']) 
    param['mu_p']=param['ssw']*param['ssh']*(1-param['sstau'])/param['ssc']
    return param


def finsum(co,st,fi):
    #geometric sum from st to fi
    return (co**st-(co)**(fi+1))/(1-co)

def dubsum(co,st,fi):
    #geometric sum with i=st to fi, with each element multiplied by a sum from j=1 to i
    return (((co-1)*(fi+1-st)-1)*co**(fi+1)+co**st)/(1-co)**2


def yEpterm(st,**par):
    #total contribtuion of period st inflation for st>0 in output equation
    return -finsum(par['beta'],st,par['T'])*par['nu_r']+par['ssb']/(par['rho'])*par['beta']**st-par['ssc']*par['beta']**(par['T']+1)/(par['fount']*par['rho']*par['ssy']*par['sigma'])

def yEpterm_disc(st,**par):
    #total contribtuion of period st inflation  and interest rate expectations in Output equation
    return -finsum(par['beta'],st,par['T'])*par['nu_r']+par['ssb']/(par['rho'])*par['beta']**st


def yEiterm(st,**par):
    #total contribtuion of period st interest rate expectations in Output equation
    tot=-finsum(par['beta'],st+1,par['T'])*par['nu_r']+par['ssb']/(par['rho'])*par['beta']*par['beta']**st-par['ssc']*par['beta']**(par['T']+1)/(par['fount']*par['rho']*par['ssy']*par['sigma'])

        
    return tot 

def yEiterm_disc(st,**par):
    #total contribtuion of period st inflation  and interest rate expectations in Output equation
    return -finsum(par['beta'],st+1,par['T'])*par['nu_r']+par['ssb']/(par['rho'])*par['beta']*par['beta']**st



def iEriterm(j,**par):
    #total contribtuion of period j inflation for st>0 in invesrtment  equation
  if j==par['T']:
#      term=0
      term=(1-(1 - par['delta'])*(1-(1 - par['delta'])**par['T'] )/par['delta'])*par['beta']**par['T'] /par['kappa']
  else:
      term=-1/(par['beta']*(1 - par['delta']))/par['kappa']*(par['beta']*(1 - par['delta'])**(1-j) *(par['delta'] *(1 - par['delta'])**j - (1 - par['delta'])**j + 1)* (par['beta']**(j)* (1 - par['delta'])**(j) - par['beta']**par['T'] *(1 - par['delta'])**par['T']))/(par['beta'] *(par['delta'] - 1) *par['delta'] + par['delta'])
      if j<(par['T']-1):
          term+=1/par['kappa']*((1 - par['delta'])**(-j) *(par['delta'] *(1 - par['delta'])**j - (1 - par['delta'])**j + 1)* (par['beta']**(j + 1)* (1 - par['delta'])**(j + 1) - par['beta']**par['T'] *(1 - par['delta'])**par['T']))/(par['beta'] *(par['delta'] - 1) *par['delta'] + par['delta'])
  return  term



def Policy_hdss(A,pers_gs,pers_ts,pers_tr,**par):
#fucntion that calculates policy functions 
    
     #initialize
    pol=[0]*(par['T']+1) 
    wb_Exp=pb_Exp=yb_Exp=yb_Exp_nondisc=PowerTy_b=0
    wk_Exp=pk_Exp=yk_Exp=yk_Exp_nondisc=PowerTy_k=0
    wi_Exp=yi_Exp=pi_Exp=yi_Exp=yi_Exp_nondisc=PowerTy_i=0
    ww_Exp=pw_Exp=yw_Exp=yw_Exp_nondisc=PowerTy_w=0
    wgs_Exp=pgs_Exp=ygs_Exp=ygs_Exp_nondisc=PowerTy_gs=0
    wts_Exp=pts_Exp=yts_Exp=yts_Exp_nondisc=PowerTy_ts=0    
    wtr_Exp=ptr_Exp=ytr_Exp=ytr_Exp_nondisc=PowerTy_tr=0  
    Eri_b=[0]*(par['T']+1)
    Eri_k=[0]*(par['T']+1)
    Eri_i=[0]*(par['T']+1)
    Eri_g=[0]*(par['T']+1)
    Eri_t=[0]*(par['T']+1)
    Eri_tr=[0]*(par['T']+1)
    Eri_w=[0]*(par['T']+1)
    Einfl_b=[0]*(par['T']+1)
    Einfl_k=[0]*(par['T']+1)
    Einfl_i=[0]*(par['T']+1)
    Einfl_g=[0]*(par['T']+1)
    Einfl_t=[0]*(par['T']+1)
    Einfl_tr=[0]*(par['T']+1)
    Einfl_w=[0]*(par['T']+1)
    Ez_b=[0]*(par['T']+1)
    Ez_k=[0]*(par['T']+1)
    Ez_i=[0]*(par['T']+1)
    Ez_g=[0]*(par['T']+1)
    Ez_t=[0]*(par['T']+1)
    Ez_tr=[0]*(par['T']+1)
    Ez_w=[0]*(par['T']+1)

    coef_gs=np.zeros(10)
    coef_ts=np.zeros(10)
    coef_tr=np.zeros(10)
 #endogeneous variables: Y, Pi, b , R, K, Z, I, T, w, Pw
    lags= np.zeros((10,4))
    lags[0,:]=[ par['ybl'],par['ykl'] , 0, 0]
    lags[1,:]=[ 0, 0, 0, 0]
    lags[2,:]=[ par['bbl'],par['bkl'] , 0, 0]
    lags[3,:]=[ 0, 0, 0, 0]
    lags[4,:]=[ 0, (1-par['delta']), 0, 0]
    lags[5,:]=[0 ,par['zkl'] , 0, 0]
    lags[6,:]=[0 , 0, 1 , 0]
    lags[7,:]=[par['phi_b'] , 0, 0, 0] 
    lags[8,:]=[0 , 0, 0 , 1]
    lags[9,:]=[0 , -par['w_k'], 0 , 0]

    



    coef_b=-np.copy(A[:,2])    
    coef_k=-np.copy(A[:,4]) 
     #newly determined capital onlyshows up through future output and consumption, which are assumed to be zero afther the horiton
    coef_k[9]=0
    coef_i=-np.copy(A[:,6])  
    coef_w=-np.copy(A[:,8])  

    coef_gs[0]=pers_gs**(par['T'])
    coef_gs[1]=0
    coef_gs[2]=pers_gs**(par['T'])*par['b_g']
    coef_gs[3]=0
    coef_gs[4]=0    
    coef_gs[5]=0
    coef_gs[6]=0
    coef_gs[7]=0
    coef_gs[8]=0
    coef_gs[9]=-pers_gs**(par['T'])*par['w_g']

    coef_ts[0]=-pers_ts**(par['T'])*(par['nu_tau'])
    coef_ts[1]=0
    coef_ts[2]=pers_ts**(par['T'])*par['b_tau']
    coef_ts[3]=0
    coef_ts[4]=0    
    coef_ts[5]=0
    coef_ts[6]=0
    coef_ts[7]=0
    coef_ts[8]=0
    coef_ts[9]=pers_ts**(par['T'])*par['w_tau'] 
    
    coef_tr[7]=-pers_tr**(par['T'])

    pol[par['T']]=SolvePolicyFunctions(coef_b,coef_k,coef_i,coef_gs,coef_ts,coef_w,coef_tr,np.copy(A),lags)

    Eri_b[par['T']]=pol[par['T']][0][3]
    Eri_k[par['T']]=pol[par['T']][1][3]
    Eri_i[par['T']]=pol[par['T']][2][3]
    Eri_g[par['T']]=pol[par['T']][3][3]
    Eri_t[par['T']]=pol[par['T']][4][3]
    Eri_w[par['T']]=pol[par['T']][5][3]
    Eri_tr[par['T']]=pol[par['T']][6][3]
    Einfl_b[par['T']]=pol[par['T']][0][1]
    Einfl_k[par['T']]=pol[par['T']][1][1]
    Einfl_i[par['T']]=pol[par['T']][2][1]
    Einfl_g[par['T']]=pol[par['T']][3][1]
    Einfl_t[par['T']]=pol[par['T']][4][1]
    Einfl_w[par['T']]=pol[par['T']][5][1]
    Einfl_tr[par['T']]=pol[par['T']][6][1]
    Ez_b[par['T']]=pol[par['T']][0][5]
    Ez_k[par['T']]=pol[par['T']][1][5]
    Ez_i[par['T']]=pol[par['T']][2][5]
    Ez_g[par['T']]=pol[par['T']][3][5]
    Ez_t[par['T']]=pol[par['T']][4][5]
    Ez_w[par['T']]=pol[par['T']][5][5]
    Ez_tr[par['T']]=pol[par['T']][6][5]
    wTterm_b=pol[par['T']][0][8]
    wTterm_k=pol[par['T']][1][8]
    wTterm_i=pol[par['T']][2][8]
    wTterm_g=pol[par['T']][3][8]
    wTterm_t=pol[par['T']][4][8]
    wTterm_w=pol[par['T']][5][8]
    wTterm_tr=pol[par['T']][6][8]    

  
    #Now we loop over time periods to obtain policy functions for earlier dates
    for i in range(1,par['T']+1):
        
        ygs_Exp_nondisc,ygs_Exp,wgs_Exp,pgs_Exp,PowerTy_gs=Update_shock_coef(ygs_Exp_nondisc,ygs_Exp,wgs_Exp,pgs_Exp,PowerTy_gs,
                                                                             wb_Exp,pb_Exp,yb_Exp,yb_Exp_nondisc,PowerTy_b,
                                                                             wk_Exp,pk_Exp,yk_Exp,yk_Exp_nondisc,PowerTy_k,
                                                                             wi_Exp,pi_Exp,yi_Exp,yi_Exp_nondisc,PowerTy_i,
                                                                             ww_Exp,pw_Exp,yw_Exp,yw_Exp_nondisc,PowerTy_w,
                                                                             pol[par['T']-i+1],3,par['T']-i,**par)

        yts_Exp_nondisc,yts_Exp,wts_Exp,pts_Exp,PowerTy_ts=Update_shock_coef(yts_Exp_nondisc,yts_Exp,wts_Exp,pts_Exp,PowerTy_ts,
                                                                             wb_Exp,pb_Exp,yb_Exp,yb_Exp_nondisc,PowerTy_b,
                                                                             wk_Exp,pk_Exp,yk_Exp,yk_Exp_nondisc,PowerTy_k,
                                                                             wi_Exp,pi_Exp,yi_Exp,yi_Exp_nondisc,PowerTy_i,
                                                                             ww_Exp,pw_Exp,yw_Exp,yw_Exp_nondisc,PowerTy_w,
                                                                             pol[par['T']-i+1],4,par['T']-i,**par)
        
        ytr_Exp_nondisc,ytr_Exp,wtr_Exp,ptr_Exp,PowerTy_tr=Update_shock_coef(ytr_Exp_nondisc,ytr_Exp,wtr_Exp,ptr_Exp,PowerTy_tr,
                                                                             wb_Exp,pb_Exp,yb_Exp,yb_Exp_nondisc,PowerTy_b,
                                                                             wk_Exp,pk_Exp,yk_Exp,yk_Exp_nondisc,PowerTy_k,
                                                                             wi_Exp,pi_Exp,yi_Exp,yi_Exp_nondisc,PowerTy_i,
                                                                             ww_Exp,pw_Exp,yw_Exp,yw_Exp_nondisc,PowerTy_w,
                                                                             pol[par['T']-i+1],6,par['T']-i,**par)

   
         #input arguments of update_k_coefficients need to be not yet updated by update_b_coefficients
    
        input_tup= (deepcopy(wb_Exp),deepcopy(pb_Exp),deepcopy(yb_Exp),deepcopy(yb_Exp_nondisc),deepcopy(PowerTy_b),deepcopy(wk_Exp),deepcopy(pk_Exp),deepcopy(yk_Exp),deepcopy(yk_Exp_nondisc),deepcopy(PowerTy_k),
                    deepcopy(wi_Exp),deepcopy(pi_Exp),deepcopy(yi_Exp),deepcopy(yi_Exp_nondisc),deepcopy(PowerTy_i),deepcopy(ww_Exp),deepcopy(pw_Exp),deepcopy(yw_Exp),deepcopy(yw_Exp_nondisc),deepcopy(PowerTy_w),pol[par['T']-i+1])   

        wb_Exp,pb_Exp,yb_Exp,yb_Exp_nondisc,PowerTy_b=Update_state_coefficients(input_tup,0,par['T']-i,**par)
        wk_Exp,pk_Exp,yk_Exp,yk_Exp_nondisc,PowerTy_k=Update_state_coefficients(input_tup,1,par['T']-i,**par)
        wi_Exp,pi_Exp,yi_Exp,yi_Exp_nondisc,PowerTy_i=Update_state_coefficients(input_tup,2,par['T']-i,**par)    
        ww_Exp,pw_Exp,yw_Exp,yw_Exp_nondisc,PowerTy_w=Update_state_coefficients(input_tup,5,par['T']-i,**par) 
        
        coef_b=-np.copy(A[:,2])  
        coef_k=-np.copy(A[:,4]) 
        coef_i=-np.copy(A[:,6])  
        coef_w=-np.copy(A[:,8]) 
        
        coef_b[0]+=yb_Exp+yb_Exp_nondisc
        coef_b[1]+=pb_Exp        
        coef_b[9]+=wb_Exp    
        
        coef_k[0]+=yk_Exp+yk_Exp_nondisc
        coef_k[1]+=pk_Exp
        coef_k[9]+=wk_Exp
        
        coef_i[0]+=yi_Exp+yi_Exp_nondisc
        coef_i[1]+=pi_Exp
        coef_i[9]+=wi_Exp
        
        coef_w[0]+=yw_Exp+yw_Exp_nondisc
        coef_w[1]+=pw_Exp
        coef_w[9]+=ww_Exp
        
    
        

        Ytaut_term=pers_ts**(par['T']-i)*(-par['nu_tau']*finsum(par['beta']*pers_ts,0,i) )
        
        Wgt_term=pers_gs**(par['T']-i)*(-par['w_g']*finsum(par['OmegaBeta_w']*pers_gs,0,i) )

        
        Wtaut_term=pers_ts**(par['T']-i)*(par['w_tau']*finsum(par['OmegaBeta_w']*pers_ts,0,i) )
        
        
        
        coef_gs[0]=ygs_Exp_nondisc+ygs_Exp+pers_gs**(par['T']-i)*1
        coef_gs[1]=pgs_Exp
        coef_gs[2]=pers_gs**(par['T']-i)*par['b_g']
        coef_gs[3]=0
        coef_gs[4]=0    
        coef_gs[5]=0
        coef_gs[6]=0
        coef_gs[7]=0
        coef_gs[8]=0
        coef_gs[9]=wgs_Exp+Wgt_term  
    
        coef_ts[0]=yts_Exp_nondisc+yts_Exp+Ytaut_term
        coef_ts[1]=pts_Exp
        coef_ts[2]=pers_ts**(par['T']-i)*par['b_tau']
        coef_ts[3]=0
        coef_ts[4]=0    
        coef_ts[5]=0
        coef_ts[6]=0
        coef_ts[7]=0
        coef_ts[8]=0
        coef_ts[9]=wts_Exp +Wtaut_term     
        
        coef_tr[0]=ytr_Exp_nondisc+ytr_Exp
        coef_tr[1]=ptr_Exp
        coef_tr[2]=0
        coef_tr[3]=0
        coef_tr[4]=0    
        coef_tr[5]=0
        coef_tr[6]=0
        coef_tr[7]=-pers_tr**(par['T']-i)
        coef_tr[8]=0
        coef_tr[9]=wtr_Exp    

           
        if (i==par['T']):
            coef_b[9]+=-par['w_wt']*wTterm_b
            coef_k[9]+=-par['w_wt']*wTterm_k
            coef_i[9]+=-par['w_wt']*wTterm_i
            coef_gs[9]+=-par['w_wt']*wTterm_g
            coef_ts[9]+=-par['w_wt']*wTterm_t
            coef_w[9]+=-par['w_wt']*wTterm_w
            coef_tr[9]+=-par['w_wt']*wTterm_tr
                
        # multiply dependence of ri from 2 periods ahead onward on current b, k, and i with how ri and z at different horizons is showing up in investment equation 
        for u in range(par['T']-i+1,par['T']+1):
            coef_b[6]+=Eri_b[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_b[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
            coef_k[6]+=Eri_k[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_k[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
            coef_i[6]+=Eri_i[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_i[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
            coef_gs[6]+=Eri_g[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_g[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
            coef_ts[6]+=Eri_t[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_t[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
            coef_w[6]+=Eri_w[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_w[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
            coef_tr[6]+=Eri_tr[u]*iEriterm(u-par['T']+i,**par)+par['i_z']*Ez_tr[u]*par['beta']**(u-par['T']+i)*finsum(1-par['delta'],1,(u-par['T']+i))
        coef_b[6]+=-Einfl_b[par['T']-i+1]*iEriterm(0,**par) #one period ahead inflation expectaions are not in the above loop that starts with one period ahead real interest rates
        coef_k[6]+=-Einfl_k[par['T']-i+1]*iEriterm(0,**par)
        coef_i[6]+=-Einfl_i[par['T']-i+1]*iEriterm(0,**par)
        coef_gs[6]+=-Einfl_g[par['T']-i+1]*iEriterm(0,**par)
        coef_ts[6]+=-Einfl_t[par['T']-i+1]*iEriterm(0,**par)
        coef_w[6]+=-Einfl_w[par['T']-i+1]*iEriterm(0,**par)
        coef_tr[6]+=-Einfl_tr[par['T']-i+1]*iEriterm(0,**par)

        #Solve the system and obtain policy functions
        pol[par['T']-i]=SolvePolicyFunctions(coef_b,coef_k,coef_i,coef_gs,coef_ts,coef_w,coef_tr,np.copy(A),lags)
      
        #USe new policy functions to calcualte dependence of all future real interest rates on current state variables. 
        #In next period this is dependence of ri from 2 periods ahead onward on bcoef kcoef and icoef        
        Eri_b,Eri_k,Eri_i,Eri_g,Eri_t,Eri_w,Eri_tr=update_future_exp(pol[par['T']-i],Eri_b,Eri_k,Eri_i,Eri_g,Eri_t,Eri_w,Eri_tr,par['T']-i+1,par['T']+1,**par)
        
        
        #USe new policy functions to calcualte dependence of next periods inflation on current state variables. 
        #This is used to calcualte dependence of current real interest on state variables. 
        #In next period this is dependence of one period ahead real itnerest rate on bcoef kcoef and icoef
        Einfl_b,Einfl_k,Einfl_i,Einfl_g,Einfl_t,Einfl_w,Einfl_tr=update_future_exp(pol[par['T']-i],Einfl_b,Einfl_k,Einfl_i,Einfl_g,Einfl_t,Einfl_w,Einfl_tr,par['T']-i+1,par['T']-i+2,**par)

        #USe new policy functions to calcualte dependence of all future z's on current state variables. 
        #In next period this is dependence of z from 2 periods ahead onward on bcoef kcoef and icoef        
        Ez_b,Ez_k,Ez_i,Ez_g,Ez_t,Ez_w,Ez_tr=update_future_exp(pol[par['T']-i],Ez_b,Ez_k,Ez_i,Ez_g,Ez_t,Ez_w,Ez_tr,par['T']-i+1,par['T']+1,**par)
        
        
        wTterm_b,wTterm_k,wTterm_i,wTterm_g,wTterm_t,wTterm_w,wTterm_tr =update_future_exp_1(pol[par['T']-i],wTterm_b,wTterm_k,wTterm_i,wTterm_g,wTterm_t,wTterm_w,wTterm_tr,**par)

        Eri_b[par['T']-i]=pol[par['T']-i][0][3]-Einfl_b[par['T']-i+1]
        Eri_k[par['T']-i]=pol[par['T']-i][1][3]-Einfl_k[par['T']-i+1]
        Eri_i[par['T']-i]=pol[par['T']-i][2][3]-Einfl_i[par['T']-i+1]
        Eri_g[par['T']-i]=pol[par['T']-i][3][3]-Einfl_g[par['T']-i+1]
        Eri_t[par['T']-i]=pol[par['T']-i][4][3]-Einfl_t[par['T']-i+1]
        Eri_w[par['T']-i]=pol[par['T']-i][5][3]-Einfl_w[par['T']-i+1]
        Eri_tr[par['T']-i]=pol[par['T']-i][6][3]-Einfl_tr[par['T']-i+1]
        Einfl_b[par['T']-i]=pol[par['T']-i][0][1]
        Einfl_k[par['T']-i]=pol[par['T']-i][1][1]
        Einfl_i[par['T']-i]=pol[par['T']-i][2][1]
        Einfl_g[par['T']-i]=pol[par['T']-i][3][1]
        Einfl_t[par['T']-i]=pol[par['T']-i][4][1]
        Einfl_w[par['T']-i]=pol[par['T']-i][5][1]
        Einfl_tr[par['T']-i]=pol[par['T']-i][6][1]
        Ez_b[par['T']-i]=pol[par['T']-i][0][5]
        Ez_k[par['T']-i]=pol[par['T']-i][1][5]
        Ez_i[par['T']-i]=pol[par['T']-i][2][5]
        Ez_g[par['T']-i]=pol[par['T']-i][3][5]
        Ez_t[par['T']-i]=pol[par['T']-i][4][5]
        Ez_w[par['T']-i]=pol[par['T']-i][5][5]
        Ez_tr[par['T']-i]=pol[par['T']-i][6][5]

            
    return pol,[coef_b,coef_k,coef_i,coef_gs,coef_ts,coef_w,coef_tr]





def update_future_exp(poli,bv,kv,iv,gv,tv,wv,trv,start,finish,**par):
    bv_new=[0]*(par['T']+1)
    kv_new=[0]*(par['T']+1)
    iv_new=[0]*(par['T']+1)
    wv_new=[0]*(par['T']+1)
    for j in range(start,finish):
        bv_new[j]=bv[j]*poli[0][2]+kv[j]*poli[0][4]+iv[j]*poli[0][6]+wv[j]*poli[0][8]
        kv_new[j]=bv[j]*poli[1][2]+kv[j]*poli[1][4]+iv[j]*poli[1][6]+wv[j]*poli[1][8]
        iv_new[j]=bv[j]*poli[2][2]+kv[j]*poli[2][4]+iv[j]*poli[2][6]+wv[j]*poli[2][8]
        gv[j]+=bv[j]*poli[3][2]+kv[j]*poli[3][4]+iv[j]*poli[3][6]+wv[j]*poli[3][8]
        tv[j]+=bv[j]*poli[4][2]+kv[j]*poli[4][4]+iv[j]*poli[4][6]+wv[j]*poli[4][8]
        wv_new[j]=bv[j]*poli[5][2]+kv[j]*poli[5][4]+iv[j]*poli[5][6]+wv[j]*poli[5][8]
        trv[j]+=bv[j]*poli[6][2]+kv[j]*poli[6][4]+iv[j]*poli[6][6]+wv[j]*poli[6][8]
    return bv_new,kv_new,iv_new,gv,tv,wv_new,trv

def update_future_exp_1(poli,bv,kv,iv,gv,tv,wv,trv,**par):
    bv_new=bv*poli[0][2]+kv*poli[0][4]+iv*poli[0][6]+wv*poli[0][8]
    kv_new=bv*poli[1][2]+kv*poli[1][4]+iv*poli[1][6]+wv*poli[1][8]
    iv_new=bv*poli[2][2]+kv*poli[2][4]+iv*poli[2][6]+wv*poli[2][8]
    gv+=bv*poli[3][2]+kv*poli[3][4]+iv*poli[3][6]+wv*poli[3][8]
    tv+=bv*poli[4][2]+kv*poli[4][4]+iv*poli[4][6]+wv*poli[4][8]
    wv_new=bv*poli[5][2]+kv*poli[5][4]+iv*poli[5][6]+wv*poli[5][8]
    trv+=bv*poli[6][2]+kv*poli[6][4]+iv*poli[6][6]+wv*poli[6][8]
    return bv_new,kv_new,iv_new,gv,tv,wv_new,trv



def Update_state_coefficients(tup,var,period,**par):
# function that calcualtes coeffcients on current debt that apear through policy functions of future dates (that have already been calcualted)
    wb_Exp,pb_Exp,yb_Exp,yb_Exp_nondisc,PowerTy_b,\
    wk_Exp,pk_Exp,yk_Exp,yk_Exp_nondisc,PowerTy_k,\
    wi_Exp,pi_Exp,yi_Exp,yi_Exp_nondisc,PowerTy_i,\
    ww_Exp,pw_Exp,yw_Exp,yw_Exp_nondisc,PowerTy_w,poli=tup
 
    PowerTy_new=PowerTy_b*poli[var][2]+PowerTy_k*poli[var][4]+PowerTy_i*poli[var][6]+PowerTy_w*poli[var][8]
    y_Exp_nondisc_new=yb_Exp_nondisc*poli[var][2]+yk_Exp_nondisc*poli[var][4]+yi_Exp_nondisc*poli[var][6]+yw_Exp_nondisc*poli[var][8] #this term is kept track of seperately because al terms in it ar always discoutned by beta^T
    y_Exp_new=yb_Exp*par['beta']*poli[var][2]+yk_Exp*par['beta']*poli[var][4]+yi_Exp*par['beta']*poli[var][6]+yw_Exp*par['beta']*poli[var][8]-par['beta']**(par['T']+1)*PowerTy_new
    p_Exp_new=pb_Exp*par['OmegaBeta']*poli[var][2]+pk_Exp*par['OmegaBeta']*poli[var][4]+pi_Exp*par['OmegaBeta']*poli[var][6]+pw_Exp*par['OmegaBeta']*poli[var][8]
    w_Exp_new=wb_Exp*par['OmegaBeta_w']*poli[var][2]+wk_Exp*par['OmegaBeta_w']*poli[var][4]+wi_Exp*par['OmegaBeta_w']*poli[var][6]+ww_Exp*par['OmegaBeta_w']*poli[var][8]

    y_Exp_nondisc_new+=-par['ssc']/(par['rho']*par['ssy']*par['fount']*par['sigma'])*par['beta']**(par['T']+1)*(poli[var][3]-poli[var][1])
    y_Exp_new+=-yEpterm_disc(1,**par)*poli[var][1]+yEiterm_disc(1,**par)*poli[var][3]+par['beta']*(par['nu_y']*poli[var][0]+par['nu_z']*poli[var][5]+par['nu_w']*poli[var][8]-1/par['rho']*poli[var][7])
    p_Exp_new+=par['OmegaBeta']*(par['k_pi']*poli[var][1]+par['k_w']*poli[var][8]+par['k_z']*poli[var][5])
    w_Exp_new+=par['OmegaBeta_w']*(par['w_y']*poli[var][0]-par['w_i']*poli[var][6]-par['w_z']*poli[var][5]-par['w_w']*poli[var][8]+par['w_pw']*poli[var][9])
  
    if period < par['T']-1: # in the first iteration future kapital lies outside the horizon and is not used in expectations. later it is: 
        w_Exp_new+=-par['OmegaBeta_w']**2*par['w_k']*poli[var][4]
        y_Exp_new+=-par['beta']**2*par['nu_k']*poli[var][4]

    #update lists of terms from period T
    PowerTy_new+=-par['nu_r']*(poli[var][3]-poli[var][1])
    return (w_Exp_new,p_Exp_new,y_Exp_new,y_Exp_nondisc_new,PowerTy_new)



def Update_shock_coef(y_Exp_nondisc,y_ExpDynamic,w_ExpDynamic,p_ExpDynamic,PowerTy,
                      wb_Exp,pb_Exp,yb_Exp,yb_Exp_nondisc,PowerTy_b,
                      wk_Exp,pk_Exp,yk_Exp,yk_Exp_nondisc,PowerTy_k,
                      wi_Exp,pi_Exp,yi_Exp,yi_Exp_nondisc,PowerTy_i,
                      ww_Exp,pw_Exp,yw_Exp,yw_Exp_nondisc,PowerTy_w,
                      pol,var,period,**par):

    
    y_ExpDynamic=y_ExpDynamic*par['beta']-par['beta']**(par['T']+1)*PowerTy
    p_ExpDynamic=p_ExpDynamic*par['OmegaBeta']
    w_ExpDynamic=w_ExpDynamic*par['OmegaBeta_w']
    
    PowerTy+=PowerTy_b*pol[var][2]+PowerTy_k*pol[var][4]+PowerTy_i*pol[var][6]+PowerTy_w*pol[var][8]
    y_Exp_nondisc+=yb_Exp_nondisc*pol[var][2]+yk_Exp_nondisc*pol[var][4]+yi_Exp_nondisc*pol[var][6]+yw_Exp_nondisc*pol[var][8]
    y_ExpDynamic+=(par['beta']*yb_Exp-par['beta']**(par['T']+1)*PowerTy_b)*pol[var][2]+(par['beta']*yk_Exp-par['beta']**(par['T']+1)*PowerTy_k)*pol[var][4]+(par['beta']*yi_Exp-par['beta']**(par['T']+1)*PowerTy_i)*pol[var][6]+(par['beta']*yw_Exp-par['beta']**(par['T']+1)*PowerTy_w)*pol[var][8]
    p_ExpDynamic+=(par['OmegaBeta']*pb_Exp)*pol[var][2]+(par['OmegaBeta']*pk_Exp)*pol[var][4]+(par['OmegaBeta']*pi_Exp)*pol[var][6]+(par['OmegaBeta']*pw_Exp)*pol[var][8]
    w_ExpDynamic+=(par['OmegaBeta_w']*wb_Exp)*pol[var][2]+(par['OmegaBeta_w']*wk_Exp)*pol[var][4]+(par['OmegaBeta_w']*wi_Exp)*pol[var][6]+(par['OmegaBeta_w']*ww_Exp)*pol[var][8]

        #Add constants from policy functions of next periods inflation and output gap and current govenremtn spending and taxes  
    
    y_Exp_nondisc+=-par['ssc']/(par['rho']*par['ssy']*par['fount']*par['sigma'])*par['beta']**(par['T']+1)*(pol[var][3] -pol[var][1]) #thus term is kept track of seperately because al terms in it ar always discoutned by beta^T
    y_ExpDynamic+=-yEpterm_disc(1,**par)*pol[var][1]+yEiterm_disc(1,**par)*pol[var][3] +par['beta']*(par['nu_y']*pol[var][0]+par['nu_z']*pol[var][5]+par['nu_w']*pol[var][8]-1/par['rho']*pol[var][7])
    p_ExpDynamic+=par['OmegaBeta']*(par['k_pi']*pol[var][1]+par['k_z']*pol[var][5]+par['k_w']*pol[var][8])
    w_ExpDynamic+=par['OmegaBeta_w']*(par['w_y']*pol[var][0]+par['w_pw']*pol[var][9]-par['w_z']*pol[var][5]-par['w_w']*pol[var][8]-par['w_i']*pol[var][6])

    if period < par['T']-1: # in the first iteration future kapital lies outside the horizon and is not used in expectations. later it is: 
        w_ExpDynamic+=-par['OmegaBeta_w']**2*par['w_k']*pol[var][4]
        y_ExpDynamic+=-par['beta']**2*par['nu_k']*pol[var][4]

      #update lists of terms from period T
    PowerTy+=-par['nu_r']*(pol[var][3] -pol[var][1])
     
    return (y_Exp_nondisc,y_ExpDynamic,w_ExpDynamic,p_ExpDynamic,PowerTy)     




def eval_pol(poli,var,b_lag,k_lag,i_lag,gs,ts,w_lag,tr):
    return poli[0][var]*b_lag+poli[1][var]*k_lag+poli[2][var]*i_lag+poli[3][var]*gs+poli[4][var]*ts+poli[5][var]*w_lag+poli[6][var]*tr
    


def Expfun(pol, b_init,k_init,i_init,gst,tst,w_init,trt,pers_gs,pers_ts,pers_tr,plotexp=0, **par):
#function that calculates fundametnalists expectations, based on policy functions that are used as input. 
# the last 3 inputs are optional. these comprise policy functions of possible paths from low debt region to high debt steady state 
# if no debt limit is given (DL=None) then the fucntion assuems that we are always in the low debt region.   
    Eb=[0]*(par['T']+1)
    Ep=[0]*(par['T']+1)
    Ey=[0]*(par['T']+1)
    Ek=[0]*(par['T']+1)
    Ez=[0]*(par['T']+1)
    Ei=[0]*(par['T']+1)
    Eg=[0]*(par['T']+1)
    Et=[0]*(par['T']+1)
    Er=[0]*(par['T']+1) 
    ET=[0]*(par['T']+1) 
    Etr=[0]*(par['T']+1) 
    Ew=[0]*(par['T']+1) 
    Epw=[0]*(par['T']+1) 
    Ec=[0]*(par['T']+1) 
    Emc=[0]*(par['T']+1) 
    Eh=[0]*(par['T']+1) 
    Ea=[0]*(par['T']+1)
    Ekz=[0]*(par['T']+1)

    [Ey[0],Ep[0],Eb[0],Er[0],Ek[0],Ez[0],Ei[0],ET[0],Ew[0],Epw[0]]=[eval_pol(pol[0],var,b_init,k_init,i_init,gst,tst,w_init,trt) for var in range(10)] 
    Eg[0]=gst
    Et[0]=tst
    Etr[0]=trt
    Ec[0]=par['ssy']/par['ssc']*Ey[0]-par['ssi']/par['ssc']*Ei[0]-par['ssy']/par['ssc']*Eg[0]-par['gamma1']*par['ssk']/par['ssc']*Ez[0]
    Emc[0]=(1-par['zeta'])*Ew[0]+par['zeta']*par['gamma2']/par['gamma1']*Ez[0]
    Eh[0]=1/(1-par['zeta'])*Ey[0]-par['zeta']/(1-par['zeta'])*k_init-par['zeta']/(1-par['zeta'])*Ez[0]
    Ea[0]=b_init+par['ssk']/(par['beta']*par['ssy'])*k_init
    Ekz[0]=k_init+Ez[0]
    
     #loop through correct policy functions to obtain expectations    
    for i in range(1,par['T']+1):
        [Ey[i],Ep[i],Eb[i],Er[i],Ek[i],Ez[i],Ei[i],ET[i],Ew[i],Epw[i]]=[eval_pol(pol[i],var,Eb[i-1],Ek[i-1],Ei[i-1],gst,tst,Ew[i-1],trt) for var in range(10)] 
        Eg[i]=Eg[i-1]*pers_gs
        Et[i]=Et[i-1]*pers_ts
        Etr[i]=Etr[i-1]*pers_tr
        Ec[i]=par['ssy']/par['ssc']*Ey[i]-par['ssi']/par['ssc']*Ei[i]-par['ssy']/par['ssc']*Eg[i]-par['gamma1']*par['ssk']/par['ssc']*Ez[i]
        Emc[i]=(1-par['zeta'])*Ew[i]+par['zeta']*par['gamma2']/par['gamma1']*Ez[i]
        Eh[i]=1/(1-par['zeta'])*Ey[i]-par['zeta']/(1-par['zeta'])*Ek[i-1]-par['zeta']/(1-par['zeta'])*Ez[i]
        Ea[i]=Eb[i-1]+par['ssk']/(par['beta']*par['ssy'])*Ek[i-1]
        Ekz[i]=Ek[i-1]+Ez[i]



    yEy_sum=wEy_sum=yEp_sum=pEp_sum=wEg_sum=yEtau_sum=yET_sum=yEz_sum=pEz_sum=wEz_sum=yEw_sum=pEw_sum=wEpw_sum=wEi_sum=wEk_sum=yER_sum=iER_sum=iEz_sum=iEp_sum=0             
    yEk_sum=wEtau_sum=wEw_sum=0
    for i in range(1,par['T']+1):       
        yEy_sum+=par['beta']**i*Ey[i]
        wEy_sum+=par['OmegaBeta_w']**i*Ey[i]
        wEg_sum+=par['OmegaBeta_w']**i*Eg[i]
        yET_sum+=par['beta']**i*ET[i]
        yEz_sum+=par['beta']**i*Ez[i]
        pEz_sum+=par['OmegaBeta']**i*Ez[i]
        wEz_sum+=par['OmegaBeta_w']**i*Ez[i]
        yEw_sum+=par['beta']**i*Ew[i]
        pEw_sum+=par['OmegaBeta']**i*Ew[i]
        wEw_sum+=par['OmegaBeta_w']**i*Ew[i]
        wEpw_sum+=par['OmegaBeta_w']**i*Epw[i]        
        if i<par['T']:
            wEk_sum+=par['OmegaBeta_w']**(i+1)*Ek[i]
            yEk_sum+=par['beta']**(i+1)*Ek[i]
        wEi_sum+=par['OmegaBeta_w']**i*Ei[i]
        yEtau_sum+=par['beta']**i*Et[i]
        wEtau_sum+=par['OmegaBeta_w']**i*Et[i]
        pEp_sum+=par['OmegaBeta']**i*Ep[i]
        yEp_sum+=yEpterm(i,**par)*Ep[i]
        yER_sum+=Er[i]*yEiterm(i,**par)
        iER_sum+=Er[i]*iEriterm(i,**par)
        iEp_sum+=Ep[i]*iEriterm(i-1,**par)
        iEz_sum+=Ez[i]*par['beta']**i*finsum(1-par['delta'],1,i)

    exp_y_eq=par['nu_y']*yEy_sum -par['nu_tau']*yEtau_sum-par['nu_k']*yEk_sum+par['nu_z']*yEz_sum+par['nu_w']*yEw_sum-1/par['rho']*yET_sum-yEp_sum+yER_sum #contribtion of expectations to Is curve 
    exp_p_eq=par['k_w']*pEw_sum+par['k_z']*pEz_sum+par['k_pi']*pEp_sum    #contribtion of expectations to phillips curve
    exp_i_eq=iER_sum-iEp_sum+par['i_z']*iEz_sum    
    exp_w_eq=par['w_y']*wEy_sum-par['w_k']*wEk_sum-par['w_g']*wEg_sum+par['w_tau']*wEtau_sum-par['w_i']*wEi_sum-par['w_z']*wEz_sum+par['w_pw']*wEpw_sum-par['w_wt']*Ew[par['T']]-par['w_w']*wEw_sum   #contribtion of expectations to phillips curve
    if plotexp==1:
        Npl=len(Ez)
        # Npl=21
        plt.figure() 

        


        
        plt.subplot(3, 3, 1)
        plot([(Ea[i])*100 for i in range(Npl)],linewidth=2)
        plt.title('Beginning of period assets')
        plt.ylabel('')
        plt.xlabel('t')
        
        plt.subplot(3, 3, 2)
        plot([(Ec[i])*100 for i in range(Npl)],linewidth=2)
        plt.title('Consumption')
        plt.ylabel('Y_t')
        plt.xlabel('t')   

        
        
        plt.subplot(3, 3, 3)
        plot([(Ew[i])*100 for i in range(Npl)],linewidth=2)
        plt.title('Wages')
        plt.ylabel('mc_t')
        plt.xlabel('t')

        plt.subplot(3, 3, 4)
        plot([(Emc[i])*100 for i in range(Npl)],linewidth=2)
        plt.title('Marginal costs')
        plt.ylabel('mc_t')
        plt.xlabel('t')        

        plt.subplot(3, 3, 5)
        plot([(Ep[i])*400 for i in range(Npl)],linewidth=2)
        plt.title('inflation')
        plt.ylabel('pi_t')
        plt.xlabel('t')
        

        plt.subplot(3, 3, 6)
        plot([(Er[i])*400 for i in range(Npl)],linewidth=2)
        plt.title('Nominal interest rate')
        plt.ylabel('i_t')
        plt.xlabel('t')   
        
  
 
         
        plt.subplot(3, 3, 7)
        plot([(Er[i]-Ep[i+1])*400 for i in range(Npl-1)],linewidth=2)
        plt.title('real interest rate')
        plt.ylabel('R_t')
        plt.xlabel('t')
        plt.show() 
    
    
        plt.subplot(3, 3, 8)
        plot([(Ei[i])*100 for i in range(Npl)],linewidth=2)
        plt.title('Investment')
        plt.ylabel('I_t')
        plt.xlabel('t') 
        
                

     
        plt.subplot(3, 3, 9)
        plot([(Ey[i])*100 for i in range(Npl)],linewidth=2)
        plt.title('Output')
        plt.ylabel('Y_t')
        plt.xlabel('t')   
        #
        
  
        
        print('Assets')
        for j in range(Npl): print(j,f"{100*Ea[j]:.10f}")
        print('Consumption')
        for j in range(Npl): print(j,f"{100*Ec[j]:.10f}")
        print('Wages')
        for j in range(Npl): print(j,f"{100*Ew[j]:.10f}")
        print('Marginal costs')
        for j in range(Npl): print(j,f"{100*Emc[j]:.10f}")
        print('inflation')
        for j in range(Npl): print(j,f"{400*Ep[j]:.10f}")
        print('nominal intrest rate')
        for j in range(Npl): print(j,f"{400*Er[j]:.10f}")
        print('real interest rate')
        for j in range(Npl-1): print(j,f"{400*((Er[j]-Ep[j+1])):.10f}")
        print('investemnt')
        for j in range(Npl): print(j,f"{100*Ei[j]:.10f}")
        print('output')
        for j in range(Npl): print(j,f"{100*Ey[j]:.10f}")
    
    
   
    Ec1=par['ssy']/par['ssc']*Ey[1]-par['ssi']/par['ssc']*Ei[1]-par['ssy']/par['ssc']*Eg[1]-par['gamma1']*par['ssk']/par['ssc']*Ez[1]
    Ec0=par['ssy']/par['ssc']*Ey[0]-par['ssi']/par['ssc']*Ei[0]-par['ssy']/par['ssc']*Eg[0]-par['gamma1']*par['ssk']/par['ssc']*Ez[0]
    return (exp_y_eq,exp_p_eq,exp_i_eq,exp_w_eq,Eb[0],Ey[1],Ep[1],Eb[1],Eg[1],Et[1],Ec0,Ec1)




def SolvePolicyFunctions(DebtCoef,KapCoef,InvCoef,gscoef,tscoef,wCoef,trcoef,matr,lags):
#function that sovles policy fucntions from linear sytem of 3 equations and 4 or 5 unknowns
#when init is yes, we are calcualting the intial period where lagegd interest rate is a state varibale and should be considered the 5th unknown.
#    print('wCoef',wCoef)

    pol_coef=np.zeros(shape=(7,10))   
    ind=0
    vec=np.zeros(10)
    for grid in [[1,0,0,0,0,0,0],[0,1,0,0,0,0,0],[0,0,1,0,0,0,0],[0,0,0,1,0,0,0],[0,0,0,0,1,0,0],[0,0,0,0,0,1,0],[0,0,0,0,0,0,1]]: 
        for row in range(10):
            matr[row][2]=-DebtCoef[row]
            matr[row][4]=-KapCoef[row]
            matr[row][6]=-InvCoef[row]
            matr[row][8]=-wCoef[row]
            vec[row]=(grid[0]*lags[row,0]+grid[1]*lags[row,1]+grid[2]*lags[row,2]+grid[3]*gscoef[row]+grid[4]*tscoef[row]+grid[5]*lags[row,3]+grid[6]*trcoef[row] )  

        pol_coef[ind,:]=np.linalg.solve(matr,vec)

        ind+=1 
    return pol_coef 



    
