# -*- coding: utf-8 -*-
"""
Created on Tue Dec 22 13:28:30 2015

@author: Joep
"""

from jmcb_exp_fun_wage import *
import numpy as np
import matplotlib.pyplot as plt
import matplotlib as mpl

from scipy.optimize import fsolve


plot = plt.plot


import pandas as pd


N=30

plotexp=0



param=dict(
    T=170,
    fount=1-0.99,
    beta=0.99,
    omega=0.8,
    omega_w=0.0000000000000001,
    eta=1.5, 
    sigma=2,
    zeta=0.2,#power on kaptial in production function
    theta=2,
    theta_w=2,
    phi_1=1.5,
    phi_2=0.2,
    phi_b=0.06,
    sstau=0.4,
    ssg=0.2,
    ssb=0.7,
    gamma1=1/0.99-1+0.025,   
    gamma2=0.05,
    delta=0.025    #depreciation rate
    kappa= 17 #investment adjustmentcost
    )


pers=0.97
Tvalues=np.arange(start=10,stop=110,step=1)
mult_g=np.zeros((len(Tvalues),4))
mult_t=np.zeros((len(Tvalues),4))
mult_tr=np.zeros((len(Tvalues),4))

ij=-1
for param['T'] in Tvalues:
    ij+=1

    pers_gs=pers
    pers_ts=pers
    pers_tr=pers
    
    param=UpdateParam(**param)  
    

#order of variablesin A : Y P b R K Z I LT w Wp

    A=np.zeros((10,10))
    
    A[0]=[1-param['nu_y'],-param['yp'],0,-yEiterm(0,**param),param['beta']*param['nu_k'],-(param['nu_z']+param['gamma1']*param['ssk']/param['ssy']),-param['ssi']/param['ssy'],1/param['rho'],-param['nu_w'],0] 
    A[1]=[0,1,0,0,0,-param['k_z'],0,0,-param['k_w'],0]
    A[2]=[-param['b_y'],param['ssb']/param['beta'],1,-param['ssb'],0,-param['b_z'],0,1/param['beta'],-param['b_w'],0]
    A[3]=[-param['phi_2'],-param['phi_1'],0,1,0,0,0,0,0,0]
    A[4]=[0,0,0,0,1,0,-param['ssi']/param['ssk'],0,0,0]
    A[5]=[-param['z_y'],0,0,0,0,param['z_z'],0,0,-param['z_w'],0]
    A[6]=[0,0,0,-iEriterm(0,**param),0,0,1,0,0,0]
    A[7]=[0,0,0,0,0,0,0,1,0,0]
    A[8]=[0,1,0,0,0,0,0,0,1,-1]
    A[9]=[-param['w_y'],0,0,0,param['OmegaBeta_w']*param['w_k'],param['w_z'],param['w_i'],0,param['w_w'],1]
    
    shock=0.01

 
    
    C=[[0]*(N) for hhh in range(4)]
    Y=[[0]*N   for hhh in range(4)]
    R=[[0]*N   for hhh in range(4)]
    P=[[0]*N  for hhh in range(4)]
    B=[[0]*N  for hhh in range(4)]
    K=[[0]*N  for hhh in range(4)]
    INV=[[0]*N  for hhh in range(4)]
    Z=[[0]*N  for hhh in range(4)]
    Q=[[0]*N  for hhh in range(4)]
    g=[[0]*N  for hhh in range(4)]
    tau=[[0]*N   for hhh in range(4)]
    Trans=[[0]*N   for hhh in range(4)]
    LST=[[0]*N   for hhh in range(4)]
    C=[[0]*N   for hhh in range(4)]
    ri=[[0]*N   for hhh in range(4)]
    H=[[0]*N   for hhh in range(4)]
    H2=[[0]*N   for hhh in range(4)]
    w=[[0]*N   for hhh in range(4)]
    w2=[[0]*N   for hhh in range(4)]
    mc=[[0]*N   for hhh in range(4)]
    Pw=[[0]*N   for hhh in range(4)]
    H4=[[0]*N   for hhh in range(4)]
    rk=[[0]*N   for hhh in range(4)]
    
    mc=[[0]*(N) for hhh in range(4)]
    prof=[[0]*(N) for hhh in range(4)]
    
    Ey1=[0]*N 
    Ep1=[0]*N 
    Eb1=[0]*N 
    Eb0=[0]*N 
    Er1=[0]*N 
    Ek1=[0]*N  
    Ez1=[0]*N  
    Eyf1=[0]*N  
    Epf1=[0]*N  
    Ebf1=[0]*N  
    Egf1=[0]*N  
    Etf1=[0]*N  
    Ecf1=[0]*N  
    Ecf0=[0]*N  
    Ei1=[0]*N  
    ET1=[0]*N  
    Ew1=[0]*N  
    Epw1=[0]*N  
    
    
    Ey=[0]*N 
    Ep=[0]*N 
    Eg=[0]*N 

    types=[0,1,2,3]
    for spen in types:  #1 is spending, 0 is labor tax, 3 is transfers, 2 is no fsical shock
    
        lags=np.zeros(13)
    
    
        
        Update_hd_pol=1 #new policy functions for the high debt steady tstate path need to be calcualted untill this is set to zero
    
        
        for i in range(1,N):
            if i>1:
                g[spen][i]=g[spen][i-1]*pers_gs
                tau[spen][i]=tau[spen][i-1]*pers_ts
                Trans[spen][i]=Trans[spen][i-1]*pers_tr
            else:
                g[1][1]=-shock
                tau[0][1]=shock*param['ssy']/(param['ssh']*param['ssw'])
                Trans[3][1]=-shock



                
            if Update_hd_pol==1:                
                pol_matrix,_=Policy_hdss(A,pers_gs,pers_ts,pers_tr,**param) #update policy fucntions
                Update_hd_pol=0
     
           # expectatinos  

            [exp_IS,exp_Phil,exp_Inv,exp_Pw,Eb0[i],Eyf1[i],Epf1[i],Ebf1[i],Egf1[i],Etf1[i],Ecf0[i],Ecf1[i]]=Expfun(pol_matrix,B[spen][i-1],K[spen][i-1],INV[spen][i-1],g[spen][i],tau[spen][i],w[spen][i-1],Trans[spen][i],pers_gs,pers_ts,pers_tr,plotexp,**param)
    
            [Ey1[i],Ep1[i],Eb1[i],Er1[i],Ek1[i],Ez1[i],Ei1[i],ET1[i],Ew1[i],Epw1[i]]=[eval_pol(pol_matrix[1],var,B[spen][i-1],K[spen][i-1],INV[spen][i-1],g[spen][i],tau[spen][i],w[spen][i-1],Trans[spen][i]) for var in range(10)] 
    

    
            RHS=np.zeros(10)
    
            
            
            RHS[0]=1/param['rho']*B[spen][i-1]+param['ykl']*K[spen][i-1]+g[spen][i]-param['nu_tau']*tau[spen][i]+exp_IS
            RHS[1]=exp_Phil
            RHS[2]=param['bkl']*K[spen][i-1]+1/param['beta']*B[spen][i-1]+param['b_g']*g[spen][i]+param['b_tau']*tau[spen][i]
            RHS[3]=0
            RHS[4]=(1-param['delta'])*K[spen][i-1]
            RHS[5]=param['zkl']*K[spen][i-1]
            RHS[6]=INV[spen][i-1]+exp_Inv
            RHS[7]=param['phi_b']*B[spen][i-1]-Trans[spen][i]
            RHS[8]=w[spen][i-1]
            RHS[9]=-param['w_k']*K[spen][i-1]-param['w_g']*g[spen][i]+param['w_tau']*tau[spen][i]+exp_Pw
        
       
            Y[spen][i],P[spen][i],B[spen][i],R[spen][i],K[spen][i],Z[spen][i],INV[spen][i],LST[spen][i],w[spen][i],Pw[spen][i]=np.dot(np.linalg.inv(A),RHS)
            ri[spen][i-1]=R[spen][i-1]-P[spen][i]
                      
        
         

    spen=1
    mult_g[ij,:]=[(np.sum([ np.prod(1/(np.array(ri[spen][1:mu+1])*(1/param['beta'])+1/param['beta'])) *(Y[spen][mu]-Y[2][mu])   for mu in range(1,1+ind)]))\
            /((np.sum([ np.prod(1/(np.array(ri[spen][1:mu+1])*(1/param['beta'])+1/param['beta'])) *(g[spen][mu]-g[2][mu])   for mu in range(1,1+ind)]))) for ind in [1,8,12,20]]
    spen=0
    mult_t[ij,:]=[(np.sum([ np.prod(1/(np.array(ri[spen][1:mu+1])*(1/param['beta'])+1/param['beta'])) *(Y[spen][mu]-Y[2][mu])   for mu in range(1,1+ind)]))\
            /((np.sum([ np.prod(1/(np.array(ri[spen][1:mu+1])*(1/param['beta'])+1/param['beta'])) *param['ssw']*param['ssh']/(param['ssy'])*(tau[spen][mu]-tau[2][mu])   for mu in range(1,1+ind)]))) for ind in [1,8,12,20]]
    
    spen=3
    mult_tr[ij,:]=[(np.sum([ np.prod(1/(np.array(ri[spen][1:mu+1])*(1/param['beta'])+1/param['beta'])) *(Y[spen][mu]-Y[2][mu])   for mu in range(1,1+ind)]))\
            /((np.sum([ np.prod(1/(np.array(ri[spen][1:mu+1])*(1/param['beta'])+1/param['beta'])) *(Trans[spen][mu]-Trans[2][mu])   for mu in range(1,1+ind)]))) for ind in [1,8,12,20]]
    
plt.figure(10)
for ik in [0,2,3]:
    plt.plot(Tvalues[:],mult_g[:,ik])    
    
    
plt.figure(11)
for ik in [0,2,3]:
    plt.plot(Tvalues[:],np.abs(mult_t[:,ik])) 
            
    
plt.figure(12)
for ik in [0,2,3]:
    plt.plot(Tvalues[:],mult_tr[:,ik])   
    # plt.ylim(-0.125,0.075)    
